routes/web.php
<?php

use App\Http\Controllers\ExpenseController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


//Route::group(['middleware' => 'role:employee'], function() {
//
//
//
//});
Route::resource('/expenses', ExpenseController::class);
Route::put('/expenses/{id}/approve', [ExpenseController::class, 'approve'])->name('expenses.approve');


Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Expense.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Expense extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'is_approved',
        'attachment',
        'amount',
        'date'
    ];
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function isManager()
    {
        if($this->role == 1)
        {
            return true;
        }
        return false;
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/ExpenseController.php
<?php

namespace App\Http\Controllers;

use App\Models\Expense;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;

class ExpenseController extends Controller
{
    public function index()
    {
        $expenses = Expense::all();

        return view('expenses.index', compact('expenses'));
    }

    public function store(Request $request)
    {
        $request->validate([
            'name'=>'required',
            'attachment'=>'required',
            'amount'=>'required',
            'date'=>'required'
        ]);

        $fileName = $request->file('attachment')->getClientOriginalName();
        $request->file('attachment')->storeAs("attachments", $fileName);

        $expense = new Expense([
            'name' => $request->get('name'),
            'attachment' => $fileName,
            'amount' => $request->get('amount'),
            'date' => $request->get('date')
        ]);

        $expense->save();
        return redirect('/expenses')->with('success', 'Expense saved!');
    }

    public function create()
    {
        return view('expenses.create');
    }

    public function show($id)
    {
        $expense = Expense::find($id);
        return response()->json($expense);
    }

    public function update($id, Request $request)
    {
        $request->validate([
            'name'=>'required',
            'attachment'=>'required',
            'amount'=>'required',
            'date'=>'required'
        ]);

        Expense::find($id)->update(['name'=>$request->get('name'),
                                               'attachment' => $request->get('attachment'),
                                               'amount' => $request->get('amount'),
                                               'date' => $request->get('date')
        ]);

        return redirect('/expenses')->with('success', 'Expense updated!');
    }

    public function edit($id)
    {
        $expense = Expense::find($id);
        return view('expenses.edit', compact('expense'));
    }

    public function destroy($id)
    {
        Expense::find($id)->delete();

        return redirect('/expenses')->with('success', 'Expense Deleted!');
    }

    public function approve($id)
    {
        if (Auth::user()->isManager())
        {
            Expense::find($id)->update(['is_approved' => 1]);

            return redirect('/expenses')->with('success', 'Expense updated!');
        }
    }
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/PremissionController.php
<?php


namespace App\Http\Controllers;

use App\Models\Permission;
use App\Models\Role;
use App\Models\User;
use Illuminate\Http\Request;

class PermissionController extends Controller
{

    public function Permission()
    {
        $dev_permission = Permission::where('slug','create-tasks')->first();
        $manager_permission = Permission::where('slug', 'edit-users')->first();

        //RoleTableSeeder.php
        $dev_role = new Role();
        $dev_role->slug = 'employee';
        $dev_role->name = 'Accounting Member';
        $dev_role->save();
        $dev_role->permissions()->attach($dev_permission);

        $manager_role = new Role();
        $manager_role->slug = 'manager';
        $manager_role->name = 'CEO';
        $manager_role->save();
        $manager_role->permissions()->attach($manager_permission);

        $dev_role = Role::where('slug','employee')->first();
        $manager_role = Role::where('slug', 'manager')->first();

        $createTasks = new Permission();
        $createTasks->slug = 'create-expenses';
        $createTasks->name = 'Create Expenses';
        $createTasks->save();
        $createTasks->roles()->attach($dev_role);

        $editUsers = new Permission();
        $editUsers->slug = 'edit-expenses';
        $editUsers->name = 'Edit Expenses';
        $editUsers->save();
        $editUsers->roles()->attach($manager_role);

        $employee_role = Role::where('slug','developer')->first();
        $manager_role = Role::where('slug', 'manager')->first();
        $employee_perm = Permission::where('slug','create-expenses')->first();
        $manager_perm = Permission::where('slug','edit-users')->first();

        $developer = new User();
        $developer->name = 'Employee';
        $developer->email = 'harsukh21@gmail.com';
        $developer->password = bcrypt('harsukh21');
        $developer->save();
        $developer->roles()->attach($employee_role);
        $developer->permissions()->attach($employee_perm);

        $manager = new User();
        $manager->name = 'Manager';
        $manager->email = 'jitesh21@gmail.com';
        $manager->password = bcrypt('jitesh21');
        $manager->save();
        $manager->roles()->attach($manager_role);
        $manager->permissions()->attach($manager_perm);


        return redirect()->back();
    }
}

resources/views/base.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Mini Expenses App</title>
    <link href="{{ asset('css/app.css') }}" rel="stylesheet" type="text/css" />

    <link href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap" rel="stylesheet">

    <style>
        body {
            font-family: 'Nunito';
        }
    </style>
</head>
<body class="antialiased">
<div class="relative flex items-top justify-center min-h-screen bg-gray-100 dark:bg-gray-900 sm:items-center sm:pt-0">
    @if (Route::has('login'))
        <div class="hidden fixed top-0 right-0 px-6 py-4 sm:block">
            @auth
                <a href="{{ url('/home') }}" class="text-sm text-gray-700 underline">Home</a>
                <a href="{{ route('logout') }}" onclick="event.preventDefault(); document.getElementById('logout-form').submit();">
                    Logout
                </a>

                <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                    {{ csrf_field() }}
                </form>
            @else
                <a href="{{ route('login') }}" class="text-sm text-gray-700 underline">Log in</a>

                @if (Route::has('register'))
                    <a href="{{ route('register') }}" class="ml-4 text-sm text-gray-700 underline">Register</a>
                @endif
            @endauth
        </div>
    @endif


</div>

<div class="container">
    @yield('main')
</div>

</body>
<script src="{{ asset('js/app.js') }}" type="text/js"></script>
</html>

resources/views/expenses/create.blade.php
@extends('welcome')

@section('main')
    <div class="row">
        <div class="col-sm-8 offset-sm-2">
            <h1 class="display-3">Add a Expenses</h1>
            <div>
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div><br />
                @endif
                <form method="post" enctype="multipart/form-data" action="{{ route('expenses.store') }}">
                    @csrf
                    <div class="form-group">
                        <label for="name">Name:</label>
                        <input type="text" class="form-control" name="name"/>
                    </div>

                    <div class="form-group">
                        <label for="amount">Amount:</label>
                        <input type="text" class="form-control" name="amount"/>
                    </div>

                    <div class="form-group">
                        <input type="file" name="attachment" placeholder="Choose file" id="file">
                        @error('attachment')
                        <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="date">Date</label>
                        <input type="date" class="form-control" name="date"/>
                    </div>
                    <button type="submit" class="btn btn-primary-outline">Add Expense</button>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/expenses/edit.blade.php
@extends('welcome')
@section('main')
    <div class="row">
        <div class="col-sm-8 offset-sm-2">
            <h1 class="display-3">Update a expense</h1>

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
                <br />
            @endif
            <form method="post" action="{{ route('expenses.update', $expense->id) }}">
                @method('PATCH')
                @csrf
                <div class="form-group">

                    <label for="name">Name:</label>
                    <input type="text" class="form-control" name="name" value={{ $expense->name }} />
                </div>

                <div class="form-group">
                    <label for="last_name">Amount:</label>
                    <input type="text" class="form-control" name="amount" value={{ $expense->amount }} />
                </div>

                <div class="form-group">
                    <label for="email">Details:</label>
                    <input type="text" class="form-control" name="attachment" value={{ $expense->attachment }} />
                </div>
                <div class="form-group">
                    <label for="city">Date:</label>
                    <input type="date" class="form-control" name="date" value={{ $expense->date }} />
                </div>
                <button type="submit" class="btn btn-primary">Update</button>
            </form>
        </div>
    </div>
@endsection

resources/views/expenses/index.blade.php
@extends('welcome')

@section('main')
    <div class="row">
        <div class="col-sm-12">
            <div class="col-sm-12">
                @if(session()->get('success'))
                    <div class="alert alert-success">
                        {{ session()->get('success') }}
                    </div>
                @endif
            </div>
            <h1 class="display-3">Expenses</h1>
            <button type="button" class="btn btn-success" onclick="window.location='{{ url("expenses/create") }}'">Add New Expense</button>
            <div style="margin-bottom: 20px"></div>
            <table class="table table-striped">
                <thead>
                <tr>
                    <td>ID</td>
                    <td>Name</td>
                    <td>Amount</td>
                    <td>Attachment</td>
                    <td>Date</td>
                    @if(auth()->user()->isManager())
                    <td colspan = 3>Actions</td>
                    @endif
                </tr>
                </thead>
                <tbody>
                @foreach($expenses as $expense)
                    <tr>
                        <td>{{$expense->id}}</td>
                        <td>{{$expense->name}}</td>
                        <td>{{$expense->amount}}</td>
                        <td> <a href="{{'storage/app/attachments/'.$expense->attachment}}
                            " >{{$expense->attachment}}</a></td>
                        <td>{{$expense->date}}</td>
                        <td>
                            @if(auth()->user()->isManager())
                                <a href="{{ route('expenses.edit',$expense->id)}}" class="btn btn-primary">Edit</a>
                            @endif
                        </td>
                        <td>
                            @if(auth()->user()->isManager())
                            <form action="{{ route('expenses.destroy', $expense->id)}}" method="post">
                                @csrf
                                @method('DELETE')
                                <button class="btn btn-danger" type="submit">Delete</button>
                            </form>
                            @endif
                        </td>
                        <td>
                            @if($expense->is_approved == 0 && auth()->user()->isManager())
                                <form action="{{ route('expenses.approve', $expense->id)}}" method="post">
                                    @csrf
                                    @method('PUT')
                                    <button class="btn btn-success" type="submit">Approve</button>
                                </form>
                            @endif
                        </td>


                    </tr>
                @endforeach
                </tbody>
            </table>
            <div>
            </div>
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Mini Expense App') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('Welcome To Expense System, you can mange (add - edit - delete - approve) and also list all expenses ') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                        {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>